<!--
 -------------------------------------------------------------------------------
 MIT License

 Copyright (c) 2024 University College Cork (UCC)
 
 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:
 
 The above copyright notice and this permission notice shall be included in all
 copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 SOFTWARE.
  
   
 SPDX-License-Identifier: MIT
   
 Contributors:
    Panagiotis Kyziropoulos - Author
    Dimitrios Bikoulis - Co-author
 
 ------------------------------------------------------------------------------- 
-->
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.4/jquery.min.js"></script>
    <title>Data Products</title>
    <link rel="stylesheet" href="css/styles.css">
</head>
<body>
    <div class="header">
            <div class="header-container">
                <img src="images/logo.png" alt="Logo">
                <button onclick="location.href='/'">Home</button>
                <button onclick="location.href='/data-products'">Data Products</button>
            </div>
    </div>
    <div class="main">
        <div class="main-container">
            <div class="table-container">
                <table>
                <thead>
                    <tr>
                    <th>ID</th>
                    <th>Name</th>
                    <th>Description</th>
                    <th style="text-align: center;">Publish</th>
                    </tr>
                </thead>
                <tbody>
                    <tr id="r1" style="cursor:pointer;" onclick="plot(1);">
                    <td id="id1"></td>
                    <td id="name1"></td>
                    <td id="desc1"></td>
                    <td style="text-align: center;"><button id="button1" class="publish" onclick="publish(1)">Publish</button></td>
                    </tr>
                    <tr id="r2" style="cursor:pointer;" onclick="plot(2);">
                        <td id="id2"></td>
                        <td id="name2"></td>
                        <td id="desc2"></td>
                        <td style="text-align: center;"><button id="button2" class="publish" onclick="publish(2)">Publish</button></td>
                    </tr>
                    <tr id="r3" style="cursor:pointer;" onclick="plot(3);">
                        <td id="id3"></td>
                        <td id="name3"></td>
                        <td id="desc3"></td>
                        <td style="text-align: center;"><button id="button3" class="publish" onclick="publish(3)">Publish</button></td>
                    </tr>
                    <!-- Add more rows as needed -->
                </tbody>
                </table>
            </div>
            <div id="catalog-entry" class="catalog-container">
            </div>
        </div>
    </div>

    <script>
        let mdata1, mdata2, mdata3;

        function getCookie(cname) {
            var name = cname + "=";
            var decodedCookie = decodeURIComponent(document.cookie);
            var ca = decodedCookie.split(';');
            for(var i = 0; i <ca.length; i++) {
                var c = ca[i];
                while (c.charAt(0) == ' ') {
                c = c.substring(1);
                }
                if (c.indexOf(name) == 0) {
                return c.substring(name.length, c.length);
                }
            }
            return false;
        }

        function loadData(num) {
            mdata1=data1;
            mdata2=data2;
            mdata3=data3;
            document.getElementById("id1").innerText=mdata1["entity"]["entityID"];
            document.getElementById("name1").innerText=mdata1["entity"]["entityQualifiedName"];
            document.getElementById("desc1").innerText=mdata1["entity"]["entityDescription"];

            document.getElementById("id2").innerText=mdata2["entity"]["entityID"];
            document.getElementById("name2").innerText=mdata2["entity"]["entityQualifiedName"];
            document.getElementById("desc2").innerText=mdata2["entity"]["entityDescription"];

            document.getElementById("id3").innerText=mdata3["entity"]["entityID"];
            document.getElementById("name3").innerText=mdata3["entity"]["entityQualifiedName"];
            document.getElementById("desc3").innerText=mdata3["entity"]["entityDescription"];
            document.getElementById("catalog-entry").style.display="none";
            document.getElementById("button1").disabled=true;
            document.getElementById("button2").disabled=true;
            document.getElementById("button3").disabled=true;

        }

        function plot(num) {
            document.getElementById("catalog-entry").style.display="flex";
            let metadata;
            
            if (num==1){
                metadata=mdata1;
                document.getElementById("r1").style.backgroundColor="#c5c5c5";
                document.getElementById("r2").style.backgroundColor="#f4f4f4";
                document.getElementById("r3").style.backgroundColor="#f4f4f4";
                document.getElementById("button1").disabled=false;
                document.getElementById("button2").disabled=true;
                document.getElementById("button3").disabled=true;

                
            }else if (num==2){
                metadata=mdata2;
                document.getElementById("r2").style.backgroundColor="#c5c5c5";
                document.getElementById("r1").style.backgroundColor="#f4f4f4";
                document.getElementById("r3").style.backgroundColor="#f4f4f4";
                document.getElementById("button2").disabled=false;
                document.getElementById("button1").disabled=true;
                document.getElementById("button3").disabled=true;
            }else{
                metadata=mdata3;
                document.getElementById("r3").style.backgroundColor="#c5c5c5";
                document.getElementById("r1").style.backgroundColor="#f4f4f4";
                document.getElementById("r2").style.backgroundColor="#f4f4f4";
                document.getElementById("button3").disabled=false;
                document.getElementById("button1").disabled=true;
                document.getElementById("button2").disabled=true;                
            }


            // get main div
            const catalogEntry=document.getElementById("catalog-entry");
            catalogEntry.innerHTML='';
            
            // Create and append the catalog title
            const catalogTitleContainer = document.createElement("div");
            catalogTitleContainer.className = "catalog-title";

            const catalogTitle = document.createElement("div");
            catalogTitle.id = "catalog-title";
            catalogTitle.style.fontSize = "1.5em";
            catalogTitle.style.fontWeight = "bold";
            catalogTitle.style.paddingBottom = "5px";
            catalogTitle.textContent = metadata["entity"]["entityQualifiedName"];

            const catalogDescription = document.createElement("div");
            catalogDescription.id = "catalog-description";
            catalogDescription.style.color = "rgb(133, 133, 133)";
            catalogDescription.style.borderBottom = "1px solid gray";
            catalogDescription.style.paddingBottom = "10px";
            catalogDescription.textContent = metadata["entity"]["entityDescription"];

            catalogTitleContainer.appendChild(catalogTitle);
            catalogTitleContainer.appendChild(catalogDescription);
            catalogEntry.appendChild(catalogTitleContainer);

            // Create and append the term container
            const termContainer = document.createElement("div");
            termContainer.className = "term-container";

            const termTitle = document.createElement("div");
            termTitle.className = "term-title";
            termTitle.innerHTML = "Terms";

            termContainer.appendChild(termTitle);

            const termInfo = document.createElement("div");
            termInfo.className = "term-info";

            metadata["glossary"].forEach(field=> {

                const termBox = document.createElement("div");
                termBox.className = "info-term-box";

                const termBoxTitle = document.createElement("div");
                termBoxTitle.className = "info-box-title";
                termBoxTitle.textContent = "Glossary";

                const termBoxMain = document.createElement("div");
                termBoxMain.className = "info-box-main";

                const termBoxFields = [
                    { label: "ID:", value: field["id"] },
                    { label: "Name:", value: field["name"] },
                    { label: "Short Description:", value: field["shortDescription"] },
                    { label: "Long Description:", value: field["longDescription"] },
                    { label: "Created At:", value: field["createdAt"] },
                    { label: "Updated At:", value: field["updatedAt"] }
                ];

                termBoxFields.forEach(field => {
                    const row = document.createElement("div");
                    row.className = "info-box-main-row";

                    const label = document.createElement("div");
                    label.style.fontWeight = "bold";
                    label.style.marginRight = "5px";
                    label.textContent = field.label;

                    const value = document.createElement("div");
                    value.textContent = field.value;

                    row.appendChild(label);
                    row.appendChild(value);
                    termBoxMain.appendChild(row);
                });

                termBox.appendChild(termBoxTitle);
                termBox.appendChild(termBoxMain);
                termInfo.appendChild(termBox);

            termContainer.appendChild(termInfo);

            });

            catalogEntry.appendChild(termContainer);


            metadata["entity"]["datasets"].forEach(field=> {

                // Create and append the dataset container
                const datasetContainer = document.createElement("div");
                datasetContainer.className = "dataset-container";

                const datasetTitle = document.createElement("div");
                datasetTitle.className = "dataset-title";
                datasetTitle.innerHTML = '<div style="margin-right: 5px;">Dataset:</div><div id="dataset-title">'+field["Dataset"]["title"]+'</div>';


                datasetContainer.appendChild(datasetTitle);

                const datasetInfo = document.createElement("div");
                datasetInfo.className = "dataset-info";

                const infoBox1 = document.createElement("div");
                infoBox1.className = "info-box";

                const infoBox1Title = document.createElement("div");
                infoBox1Title.className = "info-box-title";
                infoBox1Title.textContent = "Details";

                const infoBox1Main = document.createElement("div");
                infoBox1Main.className = "info-box-main";

                const infoBox1Fields = [
                    { label: "Title:", value: field["Dataset"]["title"] },
                    { label: "Description:", value: field["Dataset"]["description"] },
                    { label: "Creator:", value: field["Dataset"]["creator"] },
                    { label: "Created:", value: field["Dataset"]["created"] }
                ];

                infoBox1Fields.forEach(field => {
                    const row = document.createElement("div");
                    row.className = "info-box-main-row";

                    const label = document.createElement("div");
                    label.style.fontWeight = "bold";
                    label.style.marginRight = "5px";
                    label.textContent = field.label;

                    const value = document.createElement("div");
                    value.textContent = field.value;

                    row.appendChild(label);
                    row.appendChild(value);
                    infoBox1Main.appendChild(row);
                });

                infoBox1.appendChild(infoBox1Title);
                infoBox1.appendChild(infoBox1Main);

                datasetInfo.appendChild(infoBox1);

                const infoBox2 = document.createElement("div");
                infoBox2.className = "info-box";

                const infoBox2Title = document.createElement("div");
                infoBox2Title.className = "info-box-title";
                infoBox2Title.textContent = "Distribution";

                const infoBox2Main = document.createElement("div");
                infoBox2Main.className = "info-box-main";

                const infoBox2Fields = [

                    { label: "Access URL:", value: field["Dataset"]["distribution"][0]["Distribution"]["accessUrl"] },
                    { label: "Byte Size:", value: field["Dataset"]["distribution"][0]["Distribution"]["byteSize"] },
                    { label: "Media Type:", value: field["Dataset"]["distribution"][0]["Distribution"]["mediaType"] },
                    { label: "Format:", value: field["Dataset"]["distribution"][0]["Distribution"]["format"] },
                    { label: "Checksum:", value: field["Dataset"]["distribution"][0]["Distribution"]["checksum"] }
                ];

                infoBox2Fields.forEach(field => {
                    const row = document.createElement("div");
                    row.className = "info-box-main-row";

                    const label = document.createElement("div");
                    label.style.fontWeight = "bold";
                    label.style.marginRight = "5px";
                    label.textContent = field.label;

                    const value = document.createElement("div");
                    value.textContent = field.value;

                    row.appendChild(label);
                    row.appendChild(value);
                    infoBox2Main.appendChild(row);
                });

                infoBox2.appendChild(infoBox2Title);
                infoBox2.appendChild(infoBox2Main);
                datasetInfo.appendChild(infoBox2);

                field["Dataset"]["qualityMeasurements"].forEach(entry => {

                    const infoBox3 = document.createElement("div");
                    infoBox3.className = "info-box";

                    const infoBox3Title = document.createElement("div");
                    infoBox3Title.className = "info-box-title";
                    infoBox3Title.textContent = "Quality Measurements";

                    const infoBox3Main = document.createElement("div");
                    infoBox3Main.className = "info-box-main";

                    const infoBox3Fields = [
                        { label: entry["QualityMeasurement"]["isMeasurementOf"]+":", value: entry["QualityMeasurement"]["value"]+entry["QualityMeasurement"]["parameters"]["unit"] },
                        { label: "Generated By:", value: entry["QualityMeasurement"]["wasGeneratedBy"]},
                        { label: "Gen. Time:", value: entry["QualityMeasurement"]["generatedAtTime"]},
                        { label: "Threshold:", value: entry["QualityMeasurement"]["parameters"]["threshold"]+" "+entry["QualityMeasurement"]["parameters"]["unit"]}
                    ];

                    infoBox3Fields.forEach(field => {
                        const row = document.createElement("div");
                        row.className = "info-box-main-row";

                        const label = document.createElement("div");
                        label.style.fontWeight = "bold";
                        label.style.marginRight = "5px";
                        label.textContent = field.label;

                        const value = document.createElement("div");
                        value.textContent = field.value;

                        row.appendChild(label);
                        row.appendChild(value);
                        infoBox3Main.appendChild(row);
                        
                    });

                    infoBox3.appendChild(infoBox3Title);
                    infoBox3.appendChild(infoBox3Main);
                    datasetInfo.appendChild(infoBox3);

                });

                const infoBox3 = document.createElement("div");
                infoBox3.className = "info-box";

                const infoBox3Title = document.createElement("div");
                infoBox3Title.className = "info-box-title";
                infoBox3Title.textContent = "Databases";

                const infoBox3Main = document.createElement("div");
                infoBox2Main.className = "info-box-main";

                const infoBox3Fields = [

                    { label: "ID:", value: field["Dataset"]["database"]["Database"]["identifier"] },
                    { label: "Type:", value: field["Dataset"]["database"]["Database"]["dbType"] },
                    { label: "Tables:", value: field["Dataset"]["database"]["Database"]["tables"].length},
                ];

                infoBox3Fields.forEach(field => {
                    const row = document.createElement("div");
                    row.className = "info-box-main-row";

                    const label = document.createElement("div");
                    label.style.fontWeight = "bold";
                    label.style.marginRight = "5px";
                    label.textContent = field.label;

                    const value = document.createElement("div");
                    value.textContent = field.value;

                    row.appendChild(label);
                    row.appendChild(value);
                    infoBox3Main.appendChild(row);
                });

                infoBox3.appendChild(infoBox3Title);
                infoBox3.appendChild(infoBox3Main);
                datasetInfo.appendChild(infoBox3);

                field["Dataset"]["database"]["Database"]["tables"].forEach(entry => {

                    const infoBox4 = document.createElement("div");
                    infoBox4.className = "info-box";

                    const infoBox4Title = document.createElement("div");
                    infoBox4Title.className = "info-box-title";
                    infoBox4Title.textContent = "Table: "+entry["Table"]["identifier"];

                    const infoBox4Main = document.createElement("div");
                    infoBox4Main.className = "info-box-main";

                    const infoBox4Fields = [
                        { label: "Schema:", value: entry["Table"]["schema"] },
                        { label: "Encoding:", value: entry["Table"]["encoding"]},
                        { label: "Columns:", value: entry["Table"]["columns"].length},
                    ];

                    infoBox4Fields.forEach(field => {
                        const row = document.createElement("div");
                        row.className = "info-box-main-row";

                        const label = document.createElement("div");
                        label.style.fontWeight = "bold";
                        label.style.marginRight = "5px";
                        label.textContent = field.label;

                        const value = document.createElement("div");
                        value.textContent = field.value;

                        row.appendChild(label);
                        row.appendChild(value);
                        infoBox4Main.appendChild(row);
                    });

                    infoBox4.appendChild(infoBox4Title);
                    infoBox4.appendChild(infoBox4Main);
                    datasetInfo.appendChild(infoBox4);

                    entry["Table"]["columns"].forEach(items => {

                        const infoBox5 = document.createElement("div");
                        infoBox5.className = "info-box";

                        const infoBox5Title = document.createElement("div");
                        infoBox5Title.className = "info-box-title";
                        infoBox5Title.textContent = "Column: "+items["Column"]["identifier"];

                        const infoBox5Main = document.createElement("div");
                        infoBox5Main.className = "info-box-main";

                        const infoBox5Fields = [
                            { label: "Data Type:", value: items["Column"]["dataType"] },
                            { label: "Position:", value: items["Column"]["position"]},
                            { label: "Records:", value: items["Column"]["numRecords"]},
                        ];

                        infoBox5Fields.forEach(field => {
                            const row = document.createElement("div");
                            row.className = "info-box-main-row";

                            const label = document.createElement("div");
                            label.style.fontWeight = "bold";
                            label.style.marginRight = "5px";
                            label.textContent = field.label;

                            const value = document.createElement("div");
                            value.textContent = field.value;

                            row.appendChild(label);
                            row.appendChild(value);
                            infoBox5Main.appendChild(row);
                        });

                        infoBox5.appendChild(infoBox5Title);
                        infoBox5.appendChild(infoBox5Main);
                        datasetInfo.appendChild(infoBox5);

                    });
                    
                });

                datasetContainer.appendChild(datasetInfo);
                catalogEntry.appendChild(datasetContainer);
            });
        }
    
        function publish(num){
            let datapost;

            if (num==1){
                datapost =mdata1;
            }else if (num==2){
                datapost =mdata2;
            }else{
                datapost =mdata3;
            }

            let api=JSON.parse(getCookie("api"))

            // Make a POST request to the Node.js endpoint
            fetch('http://'+api['ip']+':'+api['port'].toString()+'/api/translate_metadata', {
            method: 'POST',
            headers: {
                'Content-Type': 'application/json'
            },
                body: JSON.stringify(datapost)
            })
            .then(response => response.json())
            .then(async metadata => {

                // Serialize the object to a JSON string
                const metadata_str = JSON.stringify(metadata);

                // Set the session cookie (cookie that will expire when the browser is closed)
                sessionStorage.setItem("metadata",metadata_str);

                // redirect to review metadata
                window.location.href = '/publish';

            })
            .catch(error => {
                console.error('Error:', error);
            });
        }

    </script>
    <script src="../scripts/data.js" onload="loadData()"></script>
</body>
</html>
